// Megatron.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Megatron.h"

#include "MainFrm.h"
#include "MegatronDoc.h"
#include "MegatronView.h"

#include <GameOS\GameOS.hpp>
#include <DLLPlatform\DLLPlatform.hpp>
//#include <MLR\Mlr.hpp>
//#include <GosFX\GosFX.hpp>
//#include <ElementRenderer\ElementRenderer.hpp>
//#include <ElementProxies\ElementProxies.hpp>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMegatronApp

BEGIN_MESSAGE_MAP(CMegatronApp, CWinApp)
	//{{AFX_MSG_MAP(CMegatronApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMegatronApp construction

CMegatronApp::CMegatronApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMegatronApp object

CMegatronApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMegatronApp initialization

BOOL CMegatronApp::InitInstance()
{
	char buf[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,buf);

	InitGameOS( AfxGetInstanceHandle(), NULL, "\0" );
	Stuff::ArmorLevel = 4;
	Stuff::InitializeClasses();
	//Proxies::InitializeClasses();
	//MidLevelRenderer::InitializeClasses(8192*4, 1024*256);
	//gosFX::InitializeClasses();
	//ElementRenderer::InitializeClasses();
	//ElementProxies::InitializeClasses();

	SetCurrentDirectory(buf);
	m_strRunDir = buf;	

	AfxEnableControlContainer();

	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register document templates

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMegatronDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CMegatronView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMegatronApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMegatronApp message handlers


int CMegatronApp::ExitInstance() 
{
	//ElementProxies::TerminateClasses();
	//ElementRenderer::TerminateClasses();
	//gosFX::TerminateClasses();
	//MidLevelRenderer::TerminateClasses();
	//Proxies::TerminateClasses();
	Stuff::TerminateClasses();
	ExitGameOS();

	return CWinApp::ExitInstance();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
void __stdcall GetGameOSEnvironment(char* CommandLine)
{
		//
	//----------------------------------------------------------
	// This is where to set GOS environment settings.
	//----------------------------------------------------------
	//
	Environment.applicationName			= "Megatron";
	Environment.screenWidth				= 640;
	Environment.screenHeight			= 480;
	Environment.bitDepth				= 16;
}
